package com.engine.htsc.payment.pojo;


import org.apache.commons.lang3.StringUtils;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class AutoRequestParam {
  private String relateStaffRid;
  private String creatorUid;
  private String workflowId;
  private String requestName;
  private String isNextFlow;
  Map<String, String> main;
  List<Map<String, String>> dt5;
  List<Map<String, String>> dt6;
  List<Map<String, String>> dt7;
  List<LinkedHashMap<String, String>> dt8;
  List<LinkedHashMap<String, String>> dt13;

  public String getRelateStaffRid() {
    return relateStaffRid;
  }

  public void setRelateStaffRid(String relateStaffRid) {
    this.relateStaffRid = relateStaffRid;
  }

  public String getCreatorUid() {
    return creatorUid;
  }

  public void setCreatorUid(String creatorUid) {
    this.creatorUid = creatorUid;
  }

  public String getWorkflowId() {
    return workflowId;
  }

  public void setWorkflowId(String workflowId) {
    this.workflowId = workflowId;
  }

  public String getRequestName() {
    return requestName;
  }

  public void setRequestName(String requestName) {
    this.requestName = requestName;
  }

  public String getIsNextFlow() {
    return isNextFlow;
  }

  public void setIsNextFlow(String isNextFlow) {
    this.isNextFlow = isNextFlow;
  }

  public Map<String, String> getMain() {
    return main;
  }

  public void setMain(Map<String, String> main) {
    this.main = main;
  }

  public List<Map<String, String>> getDt5() {
    return dt5;
  }

  public void setDt5(List<Map<String, String>> dt5) {
    this.dt5 = dt5;
  }

  public List<Map<String, String>> getDt6() {
    return dt6;
  }

  public void setDt6(List<Map<String, String>> dt6) {
    this.dt6 = dt6;
  }

  public List<Map<String, String>> getDt7() {
    return dt7;
  }

  public void setDt7(List<Map<String, String>> dt7) {
    this.dt7 = dt7;
  }

  public List<LinkedHashMap<String, String>> getDt8() {
    return dt8;
  }

  public void setDt8(List<LinkedHashMap<String, String>> dt8) {
    this.dt8 = dt8;
  }

  public List<LinkedHashMap<String, String>> getDt13() {
    return dt13;
  }

  public void setDt13(List<LinkedHashMap<String, String>> dt13) {
    this.dt13 = dt13;
  }

  @Override
  public String toString() {
    return "AutoRequestParam{" +
            "relateStaffRid='" + relateStaffRid + '\'' +
            ", creatorUid='" + creatorUid + '\'' +
            ", workflowId='" + workflowId + '\'' +
            ", requestName='" + requestName + '\'' +
            ", isNextFlow='" + isNextFlow + '\'' +
            ", main=" + main +
            ", dt5=" + dt5 +
            ", dt6=" + dt6 +
            ", dt7=" + dt7 +
            ", dt8=" + dt8 +
            ", dt13=" + dt13 +
            '}';
  }

  /**
   * 任一为空返回false
   */
  public boolean isValid() {
    return StringUtils.isNotBlank(creatorUid) && StringUtils.isNotBlank(workflowId)
            && StringUtils.isNotBlank(requestName) && StringUtils.isNotBlank(isNextFlow);
  }
}