package com.engine.htxc.commonutil.type;

/**
 * <p>创建对应的枚举方式</p>
 * ps:"yyyy-MM-dd" or "yyyy-MM-dd hh:mm:ss"
 * @author K1810015
 * @version 1.0.0
 * @ClassName DateEnum.java
 * @createTime 2022年08月19日 17:08:00
 */
public enum DateEnum {
    ShortSuffix("yyyy-MM-dd"),
    LongSuffix("yyyy-MM-dd hh:mi:ss");


    private DateEnum(final String value) {
        this.value=value;
    }

    public String getValue() {
        return value;
    }

    private  final String value;

}
