package com.engine.htxc.contract.dto;

import java.io.Serializable;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810050
 * @version: 1.0
 * @CreateDate: 2022/8/23 10:40
 * @Description: 对手方信息
 * @ModifyLog:
 **/
public class CounterPartyDTO implements Serializable {

    /**
     * 证书类型
     */
    private String certType;

    /**
     * 证件号码：统一社会信用代码 或身份证
     */
    private String certNo;

    public String getCertType() {
        return certType;
    }

    public void setCertType(String certType) {
        this.certType = certType;
    }

    public String getCertNo() {
        return certNo;
    }

    public void setCertNo(String certNo) {
        this.certNo = certNo;
    }

    @Override
    public String toString() {
        return "CounterPartyDTO{" + "certType='" + certType + '\'' + ", certNo='" + certNo + '\'' + '}';
    }
}
