package com.engine.htxc.eseal.business.contract.service;

import com.engine.htxc.eseal.uinterface.Eseal;
import weaver.hrm.User;

import java.util.Map;

/**
 * <p>合同相关流程处理类</p>
 * @author K1810015
 * @version 1.0.0
 * @ClassName ContractEsealService.java
 * @createTime 2022年06月21日 13:53:00
 */
public interface ContractEsealService {

    /**
     * <p>合同流程发送eseal消息</p>
     * @title sendEseal
     * @author K1810015
     * @param map 自定义传参内容
     * @param user 当前操作人
     */
     Eseal sendEseal(Map<String,Object> map, User user);

}
