package com.engine.htxc.eseal.responseaction.num;

import com.engine.integration.util.StringUtils;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName SignsStatus.java
 * @createTime 2022年08月03日 13:31:00
 */
public enum SignsStatusEnum  {
    OTHER("-1"),
    Wait("0"),
    Starting("1"),
    Rescinded("3"),
    Completed("5"),
    Refuse("6"),
    Fail("7");

    SignsStatusEnum(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    private final String value;


    public static SignsStatusEnum where(String key) {
        if(StringUtils.isBlank(key)){
            return OTHER;
        }
        SignsStatusEnum[] value= SignsStatusEnum.values();
        for(SignsStatusEnum signsStatusEnum:value){
            if(key.equals(signsStatusEnum.getValue())){
                return signsStatusEnum;
            }
        }
        return null;
    }

}
