package com.engine.htxc.workflow.create.cnum;

/**
 * <p>用于调用方（枚举类型）集成</p>
 * <p>调用方参数存在classname、classpackage可用于重载该方法直接获取</p>
 * 也可以作为返回参数
 * @version 1.0.0
 * @ClassName CworkflowType.java
 * @createTime 2022年07月17日 20:28:00
 */
public interface CworkflowType {

    /**
     * <p>用于继承方调用classname参数</p>
     * @title getClassname
     * @author K1810015
     * @updateTime 2022/8/21 23:11
     */
    public String getClassname();

    /**
     * <p>用于继承方调用classpackage方法</p>
     * @title getClasspackage
     * @author K1810015
     * @updateTime 2022/8/21 23:11
     */
    public String getClasspackage();
}
