package weaver.interfaces.htsc.cowork.entity;

import weaver.general.TimeUtil;
import weaver.general.Util;

import java.io.Serializable;
import java.util.UUID;

/**
 * Created by K1810006 on 2020/12/17.
 */
public class TaskEntity implements Serializable{

    private String bt;   //标题
    private String xzbh;  //协作编号
    private String cjzt;  //创建状态
    private Integer cjr;   //创建人
    private Integer szbm;  //所在部门
    private Integer szjg;   //所在机构
    private String cjrq;  //创建日期
    private String gllc;  //关联流程
    private String xgwj;  //相关文件
    private Integer xzsy;  //协作事宜
    private Integer xzzt;  // 协作状态
    private Integer rwzt;  //任务状态
    private Integer lx;       //类型
    private Integer yxj;     //优先级
    private String fkhz; //反馈汇总
    private String wcqk;  //完成情况
    private String sxzj; //事项总结
    private String sydx; //送阅读像
    private String bz; //备注
    private String modeuuid;//uuid
    private Integer modedatamodifier;//不需要
    private String modedatamodifydatetime;//不需要
    private Integer formmodeid;
    private Integer modedatacreater;//创建人
    private Integer modedatacreatertype = 0;
    private String modedatacreatedate;//创建日期
    private String modedatacreatetime;//创建时间

    public TaskEntity() {
        this.modeuuid = UUID.randomUUID().toString();
        this.modedatacreatedate = TimeUtil.getCurrentDateString();
        this.modedatacreatetime = TimeUtil.getOnlyCurrentTimeString();
    }



    public String getBt() {
        return bt;
    }

    public void setBt(String bt) {
        this.bt = bt;
    }

    public String getXzbh() {
        return xzbh;
    }

    public void setXzbh(String xzbh) {
        this.xzbh = xzbh;
    }

    public String getCjzt() {
        return cjzt;
    }

    public void setCjzt(String cjzt) {
        this.cjzt = cjzt;
    }

    public int getCjr() {
        return cjr;
    }

    public void setCjr(int cjr) {
        this.cjr = cjr;
    }

    public int getSzbm() {
        return szbm;
    }

    public void setSzbm(int szbm) {
        this.szbm = szbm;
    }

    public int getSzjg() {
        return szjg;
    }

    public void setSzjg(int szjg) {
        this.szjg = szjg;
    }

    public String getCjrq() {
        return cjrq;
    }

    public void setCjrq(String cjrq) {
        this.cjrq = cjrq;
    }

    public String getGllc() {
        return gllc;
    }

    public void setGllc(String gllc) {
        this.gllc = gllc;
    }

    public String getXgwj() {
        return xgwj;
    }

    public void setXgwj(String xgwj) {
        this.xgwj = xgwj;
    }

    public int getXzsy() {
        return xzsy;
    }

    public void setXzsy(int xzsy) {
        this.xzsy = xzsy;
    }

    public int getXzzt() {
        return xzzt;
    }

    public void setXzzt(int xzzt) {
        this.xzzt = xzzt;
    }

    public int getRwzt() {
        return rwzt;
    }

    public void setRwzt(int rwzt) {
        this.rwzt = rwzt;
    }

    public int getLx() {
        return lx;
    }

    public void setLx(int lx) {
        this.lx = lx;
    }

    public int getYxj() {
        return yxj;
    }

    public void setYxj(int yxj) {
        this.yxj = yxj;
    }

    public String getFkhz() {
        return fkhz;
    }

    public void setFkhz(String fkhz) {
        this.fkhz = fkhz;
    }

    public String getWcqk() {
        return wcqk;
    }

    public void setWcqk(String wcqk) {
        this.wcqk = wcqk;
    }

    public String getSxzj() {
        return sxzj;
    }

    public void setSxzj(String sxzj) {
        this.sxzj = sxzj;
    }

    public String getSydx() {
        return sydx;
    }

    public void setSydx(String sydx) {
        this.sydx = sydx;
    }

    public String getBz() {
        return bz;
    }

    public void setBz(String bz) {
        this.bz = bz;
    }

    public String getModeuuid() {
        return modeuuid;
    }

    public void setModeuuid(String modeuuid) {
        this.modeuuid = modeuuid;
    }

    public int getModedatamodifier() {
        return modedatamodifier;
    }

    public void setModedatamodifier(int modedatamodifier) {
        this.modedatamodifier = modedatamodifier;
    }

    public String getModedatamodifydatetime() {
        return modedatamodifydatetime;
    }

    public void setModedatamodifydatetime(String modedatamodifydatetime) {
        this.modedatamodifydatetime = modedatamodifydatetime;
    }

    public int getFormmodeid() {
        return formmodeid;
    }

    public void setFormmodeid(int formmodeid) {
        this.formmodeid = formmodeid;
    }

    public int getModedatacreater() {
        return modedatacreater;
    }

    public void setModedatacreater(int modedatacreater) {
        this.modedatacreater = modedatacreater;
    }

    public int getModedatacreatertype() {
        return modedatacreatertype;
    }

    public void setModedatacreatertype(int modedatacreatertype) {
        this.modedatacreatertype = modedatacreatertype;
    }

    public String getModedatacreatedate() {
        return modedatacreatedate;
    }

    public void setModedatacreatedate(String modedatacreatedate) {
        this.modedatacreatedate = modedatacreatedate;
    }

    public String getModedatacreatetime() {
        return modedatacreatetime;
    }

    public void setModedatacreatetime(String modedatacreatetime) {
        this.modedatacreatetime = modedatacreatetime;
    }

}

