package weaver.interfaces.htsc.cus;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

/**
 * 出差反馈节点的流转意见自定义：反馈选项+延期时间或提前返回时间
 *
 */
public class CustomFeddBackRemarkAction implements Action {
    private Log log = LogFactory.getLog(this.getClass());
    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = Util.null2String(requestInfo.getRequestid());
        log.info("自定义出差反馈节点的签字意见----START-----"+requestid);
        int nodeid = requestInfo.getRequestManager().getNodeid();
        RemarkThread remarkThread = new RemarkThread(requestInfo,nodeid);
        new Thread(remarkThread).start();
        log.info("自定义出差反馈节点的签字意见----END-----"+requestid);
        return Action.SUCCESS;
    }


}
