package weaver.interfaces.htsc.cus.webservices.jtgl;

import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;

/**
 * 输出参数
 *
 * @author Administrator
 */
@XStreamAlias("ZQ_RESULT")
public class OutputData {
  
  //RECEIVE_FLAG：接收标志，Y：财务系统接收处理成功；N:财务系统接收处理失败。
  @XStreamAsAttribute
  private String RECEIVE_FLAG;
  //ERROR_MSG：中文说明，出错信息。如果接收标志为N，返回出错信息，如“单据信息不完整”。
  @XStreamAsAttribute
  private String ERROR_MSG;
  
  
  public String getRECEIVE_FLAG() {
    return RECEIVE_FLAG;
  }
  
  public void setRECEIVE_FLAG(String rECEIVE_FLAG) {
    RECEIVE_FLAG = rECEIVE_FLAG;
  }
  
  public String getERROR_MSG() {
    return ERROR_MSG;
  }
  
  public void setERROR_MSG(String eRROR_MSG) {
    ERROR_MSG = eRROR_MSG;
  }
  
}
