package weaver.interfaces.htsc.cus.webservices.jtgl;

import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamImplicit;
import com.thoughtworks.xstream.annotations.XStreamOmitField;
import java.util.ArrayList;
import java.util.List;

@XStreamAlias("ZQ_FYDJ")
public class RootData {
  
  @XStreamOmitField
  private String encode = "GB2312";
  @XStreamOmitField
  private String xmlHeader = "<?xml version=\"1.0\" encoding=\"" + encode + "\"?>";
  
  @XStreamImplicit()
  private List<InputData> list = new ArrayList<InputData>();
  
  public List<InputData> getList() {
    return list;
  }
  
  public void setList(List<InputData> list) {
    this.list = list;
  }
  
  public String getEncode() {
    return encode;
  }
  
  public void setEncode(String encode) {
    this.encode = encode;
  }
  
  public String getXmlHeader() {
    return xmlHeader;
  }
  
  public void setXmlHeader(String xmlHeader) {
    this.xmlHeader = xmlHeader;
  }
  
}
