package weaver.interfaces.htsc.jgxt;

import com.engine.common.util.ServiceUtil;
import com.engine.htsc.jgxt.service.JgxtDataDetailToOtherService;
import com.engine.htsc.jgxt.service.imp.JgxtDataDetailToOtherServiceImp;
import com.engine.htsc.jgxt.service.imp.JgxtDataToOtherServiceImp;
import weaver.conn.RecordSet;
import weaver.interfaces.htsc.GlobatTools.JAVATools;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xf
 * @version 1.0.0
 * @ClassName JgxtDataDetailToOther.java
 * @createTime 2021年12月20日 13:59:00
 */
public class JgxtDataDetailToOther implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        try {
            JAVATools.SetCmdwritelog("监管协同流程", "明细表下游写入数据");
            RecordSet rs = new RecordSet();
            String requestid = requestInfo.getRequestid();
             String tablename = requestInfo.getRequestManager().getBillTableName();
            Map<String, Object> map = new HashMap<>();
            map.put("requestid", requestid);
            map.put("tablename", tablename);

            ServiceUtil.getService(JgxtDataDetailToOtherServiceImp.class).innertdetaildata(map);
        }catch (Exception exo){

        }
        return Action.SUCCESS;

    }
}
