/*
 *
 *  * Copyright (c) 2001- 泛微软件.
 *  * 泛微协同商务系统,版权所有.
 *
 */
package weaver.interfaces.htsc.wpscenter;

import java.util.Map;

/**
 * 修订接口
 * @Author leiwb
 * @Date 2020/8/6
 */
public interface RevisionInterface {

    /**
     * 接受修订
     * @param paramsMap 传参
     * @return 接受修订后的imagefileId
     */
    int acceptRevisions(Map<String, Object> paramsMap);

    /**
     * 删除修订
     * @param paramsMap
     * @return
     */
    int deleteRevisions(Map<String, Object> paramsMap);
}
