package com.engine.htxc.commonutil.user;

import com.api.formmode.page.util.Util;
import com.engine.htxc.commonutil.db.DbTools;
import com.engine.integration.util.StringUtils;
import weaver.hrm.User;

import java.io.Serializable;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>关于用户查询的方法</p>
 * @author K1810015
 * @version 1.0.0
 * @ClassName UserNew.java
 * @createTime 2022年06月24日 11:11:00
 */

public class UserTools {

    private UserTools() {

    }
    private static String fileids="*";

    private static DbTools dbtools=new DbTools();

    public static List<Map<String,Object>> getUserInfo(String ids,String fileidvalue){
        List<Map<String,Object>> list=new ArrayList<>();
        if(StringUtils.isBlank(ids)){
            return list;
        }
        if(!StringUtils.isBlank(fileidvalue)){
            fileids=fileidvalue;
        }
        String sql="select {0} from hrmresource where id in ({1})";
        return dbtools.getSqlToList(MessageFormat.format(sql,fileids,ids),(Object)null);
    }

}
