package com.engine.htxc.contract.dto;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810050
 * @version: 1.0
 * @CreateDate: 2022/8/18 21:16
 * @Description: 合同状态枚举
 * @ModifyLog:
 **/
public enum ContractStatusEnum {
    //0草稿
    DRAFT,
    //1待审批
    TO_APPROVE,
    //2审批中
    APPROVING,
    //3待签订
    TO_SIGN,
    //4已签订
    SIGN_FINISH,
    //5废弃中
    DISCARDING,
    //6已废弃
    DISCARD_FINISH,
    //7履约中
    PERFORMING,
    //8履约完成,
    PERFORM_FINISH
}
