package com.engine.htxc.contract.dto;

import java.io.Serializable;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810050
 * @version: 1.0
 * @CreateDate: 2022/8/23 16:57
 * @Description: 产品对手方关系
 * @ModifyLog:
 **/
public class ProductCounterPartyDTO implements Serializable {
    /**
     * 产品名称
     */
    private String productName;

    /**
     * 产品唯一标识
     */
    private String productCode;
    /**
     * 证件类型
     */
    private String certType;

    /**
     * 证件号码： 统一社会信用代码，身份证
     */
    private String certNo;
    /**
     * 对手方名称
     */
    private String counterPartyName;

    /**
     * 机构类型 个人 企业
     */
    private String counterPartyType;

    public String getProductName() {
        return productName;
    }

    public void setProductName(String productName) {
        this.productName = productName;
    }

    public String getProductCode() {
        return productCode;
    }

    public void setProductCode(String productCode) {
        this.productCode = productCode;
    }

    public String getCertType() {
        return certType;
    }

    public void setCertType(String certType) {
        this.certType = certType;
    }

    public String getCertNo() {
        return certNo;
    }

    public void setCertNo(String certNo) {
        this.certNo = certNo;
    }

    public String getCounterPartyName() {
        return counterPartyName;
    }

    public void setCounterPartyName(String counterPartyName) {
        this.counterPartyName = counterPartyName;
    }

    public String getCounterPartyType() {
        return counterPartyType;
    }

    public void setCounterPartyType(String counterPartyType) {
        this.counterPartyType = counterPartyType;
    }

    @Override
    public String toString() {
        return "ProductCounterPartyDTO{" + "productName='" + productName + '\'' + ", productCode='" + productCode + '\''
            + ", certType='" + certType + '\'' + ", certNo='" + certNo + '\'' + ", counterPartyName='"
            + counterPartyName + '\'' + ", counterPartyType='" + counterPartyType + '\'' + '}';
    }
}
