package com.engine.htxc.eseal.responseaction.num;

import com.engine.integration.util.StringUtils;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName EsealTypeEnum.java
 * @createTime 2022年08月03日 15:25:00
 */
public enum EsealTypeEnum {
    EOHTER("-1"),
    Electronics("0"),
    ESecurity("1"),
    Opponent("2"),
    Online("3");


    private EsealTypeEnum( final String value) {
        this.value = value;
    }
    private final String value;
    public String getValue() {
        return value;
    }


    public static EsealTypeEnum where(String key) {
        if(StringUtils.isBlank(key)){
            return EOHTER;
        }
        EsealTypeEnum[] value= EsealTypeEnum.values();
        for(EsealTypeEnum esealTypeEnum:value){
            if(key.equals(esealTypeEnum.getValue())){
                return esealTypeEnum;
            }
        }
        return null;
    }
}
