package com.engine.htxc.eseal.responseaction.num;

import com.engine.integration.util.StringUtils;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName FileSignsStatus.java
 * @createTime 2022年08月03日 11:45:00
 */
public enum FileSignsStatusEnum {
    OTHER("-1"),
    Ediet("0"),
    Starting("1"),
    Frozen("2"),
    Rescinded("3"),
    Expired("4"),
    Completed("5"),
    Refuse("6"),
    WatermarkSucess("7"),
    WatermarkRefuse("8"),
    Abandon("9");

    FileSignsStatusEnum(String value) {
        this.value = value;
    }

    public String getValue() {
        return value;
    }

    private final String value;


    public static FileSignsStatusEnum where(String key) {
        if(StringUtils.isBlank(key)){
            return OTHER;
        }
        FileSignsStatusEnum[] value= FileSignsStatusEnum.values();
        for(FileSignsStatusEnum fileSignsStatusEnum:value){
            if(key.equals(fileSignsStatusEnum.getValue())){
                return fileSignsStatusEnum;
            }
        }
        return null;
    }
}
