package com.engine.htxc.eseal.service;

import weaver.hrm.User;

import java.util.List;
import java.util.Map;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName EsealService.java
 * @createTime 2022年06月16日 13:22:00
 */
public interface EsealService {

    /**
     * <p>根据部门去建模表中取对应印章名称</p>
     * @title getsealname
     * @author K1810015
     * @updateTime 2022/9/5 10:44
     */
    public Map<String,Object> getsealname(Map<String,Object> map,User user);

    /**
     * <p>合同流程送eseal平台接口</p>
     * @title sendcontracteseal
     * @author K1810015
     * @updateTime 2022/9/5 10:46
     */
    public String sendcontracteseal(Map<String,Object> map, User user);

    /**
     * <p>根据eseal编号获取名称</p>
     * @title getSealNoToName
     * @author K1810015
     * @updateTime 2022/9/5 10:46
     */
    public List<Map<String,Object>> getSealNoToName(Map<String,Object> map, User user);

}
