package com.engine.htxc.eseal.type;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName EffectType.java
 * @createTime 2022年06月22日 16:28:00
 */
public enum EffectType implements IColumnType {

    //SINGLEWATERMARK("PAPER","0"),
    ELECTRONIC("ELECTRONIC","0"),
    PAPER("PAPER","1"),
    NOWATERMARK("NOWATERMARK","2");
    private final String key;
    private final String value;

    private EffectType(final String key, final String value) {
        this.key = key;
        this.value = value;
    }

    @Override
    public String getKey() {
        return key;
    }

    @Override
    public String getValue() {
        return value;
    }
}
