package com.engine.htxc.htqc.service.impl;

import com.engine.core.impl.Service;
import com.engine.htxc.htqc.dao.HtqcDao;
import com.engine.htxc.htqc.service.HtqcYwService;
import lombok.extern.slf4j.Slf4j;

import java.util.Map;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810039
 * @version: 1.0
 * @CreateDate: 2022-09-14 16:39
 * @Description: 合同起草 业务类型
 * @ModifyLog:
 **/
@Slf4j
public class HtqcYwServiceImpl  extends Service implements HtqcYwService {

    @Override
    public Map<String, String> getDsf(String productIds) {
        return HtqcDao.getDsfNameAndCodeDao(productIds);
    }

    @Override
    public Map<String, Object> getContractInfo(String htbhs) {
        return HtqcDao.getContractInfoDao(htbhs);
    }

    @Override
    public int getCurrentUserRole(String currentUserId) {
        return HtqcDao.getCurrentUserRole(currentUserId);
    }


}
