package com.engine.htxc.itcglc.service.impl;

import com.engine.core.impl.Service;
import com.engine.htxc.itcglc.cmd.*;
import com.engine.htxc.itcglc.service.ItcglcService;
import weaver.hrm.User;

import java.util.Map;

public class ItcglcServiceImpl extends Service implements ItcglcService {

    @Override
    public Map<String, Object> getItcgProject(Map<String, Object> params) {
        return commandExecutor.execute(new ItcglcProjectListCmd(params));
    }

    @Override
    public Map<String, Object> getItcgProjectInfo(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItcglcProjectInfoCmd(user,params));
    }

    @Override
    public Map<String, Object> getLsdpInfo(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItcglcLdspInfoCmd(user,params));
    }


    @Override
    public Map<String, Object> createFreeNode(User user, Map<String, Object> params) {
        return commandExecutor.execute(new ItcglcFreeNodeCmd(user,params));
    }

    @Override
    public Map<String, Object> getcgplanlist(Map<String, Object> params) {
        return commandExecutor.execute(new cgplanListCmd(params));
    }

    @Override
    public Map<String, Object> createCgrwdRequest(Map<String, Object> params, User user) {
        return commandExecutor.execute(new CreateRequestCmd(params,user));
    }
}
