package com.engine.htxc.workflow.create.cnum;

/**
 * <p>流程相关的创建方法的集合</p>
 * 通过CustomizeworkflowServiceImpl这个方法调用
 * 在此枚举中添加对应key->value，通过唯一标识来获取自定义的创建流程接口
 * @author K1810015
 * @version 1.0.0
 * @ClassName workflowenum.java
 * @createTime 2022年07月15日 17:23:00
 */
public enum Workflowenum  implements CworkflowType {

    ContractEnd("zbhtgd","com.engine.htxc.workflow.create.business.contract.end.service.impl.ConstractEndServiceImpl"),
    ContractDiscard("zbhtfq","com.engine.htxc.workflow.create.business.contract.end.service.impl.ConstractDiscardServiceImpl"),
    ContractSign("zbhtqd","com.engine.htxc.workflow.create.business.contract.sign.service.impl.ConstracSignServiceImpl"),
    Approvaltosign("approvaltosign","com.engine.htxc.workflow.create.business.contract.approval.service.impl.Approvaltosign"),
    Convention("convention","com.engine.htxc.workflow.create.business.contract.convention.service.impl.ConventionserviceImpl"),
    Endtosign("endtosign","com.engine.htxc.workflow.create.business.contract.approval.service.impl.Endtosign"),
    Other("-1","");
    private final String classname;
    private final String classpackage;

    private Workflowenum(final String classname, final String classpackage) {
        this.classname = classname;
        this.classpackage = classpackage;
    }

    @Override
    public String getClassname() {
        return classname;
    }

    @Override
    public String getClasspackage() {
        return classpackage;
    }
}
