package com.engine.htxc.workflow.select.web;

import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.htxc.commonutil.log.CustomizeLog;
import com.engine.htxc.commonutil.ret.Creturn;
import com.engine.htxc.workflow.select.service.WorkflowSelectService;
import com.engine.htxc.workflow.select.service.impl.WorkflowSelectServiceImpl;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

/**
 * <p>流程查询的result接口入口</p>
 * @author K1810015
 * @version 1.0.0
 * @ClassName WorkflowselectAction.java
 * @createTime 2022-08-15 09:56:00
 */
public class WorkflowSelectAction {

    private WorkflowSelectService workflowSelectService=
            ServiceUtil.getService(WorkflowSelectServiceImpl.class);

    @POST
    @Path("/getnodeflag")
    @Produces({MediaType.TEXT_PLAIN})
    public String getnodeflag(@Context HttpServletRequest request, @Context HttpServletResponse response) {
       CustomizeLog.printLog("查看参数̬"+ParamUtil.request2Map(request).toString());
       boolean flag=  workflowSelectService.getnodeflag( ParamUtil.request2Map(request));
       return Creturn.Ok(flag);

    }


}
