package weaver.interfaces.htsc.capitalbusinessPayment;

import com.engine.htsc.capitalbusinessPayment.dao.OperateLiquidationDataDao;
import com.engine.htsc.capitalbusinessPayment.service.CapitalBusinessPaymentService;
import com.engine.htsc.convertor.EcologyValueConvertor;
import com.engine.htsc.doc.model.UserInfoModel;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;
import weaver.workflow.request.RequestManager;

/**
 * 调用衡泰接口
 */
public class SendXquantAction extends BaseBean implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = Util.null2String(requestInfo.getRequestid());
        try {
            CapitalBusinessPaymentService capitalBusinessPaymentService = new CapitalBusinessPaymentService();
            capitalBusinessPaymentService.sendXquantByRequestId(requestid);
        } catch (Exception e) {
            e.printStackTrace();
            writeLog("requestId:" + requestid + " 调用衡泰接口失败"+e);
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

}
