package weaver.interfaces.htsc.cowork;

import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;

public class CoworkSaveModeThread implements Runnable {
    private int billid;
    private int userid;
    private int modeid;

    public CoworkSaveModeThread(int userid, int modeid,int billid) {
        this.billid = billid;
        this.userid = userid;
        this.modeid = modeid;
    }

    @Override
    public void run() {
        BaseBean bb = new BaseBean();
        ModeRightInfo modeRightInfo = new ModeRightInfo();
        bb.writeLog("CoworkSaveModeThread---userid:"+userid);
        bb.writeLog("CoworkSaveModeThread---modeid:"+modeid);
        bb.writeLog("CoworkSaveModeThread---billid："+billid);
        bb.writeLog("CoworkSaveModeThread---"+System.currentTimeMillis());
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        bb.writeLog("CoworkSaveModeThread---"+System.currentTimeMillis());
        try{
            modeRightInfo.rebuildModeDataShareByEdit(userid,modeid,billid);//编辑时重
        }catch (Exception e){
            e.printStackTrace();
            bb.writeLog("自定义出差反馈节点的签字意见捕获异常");
        }
    }
}
