package weaver.interfaces.htsc.jgxt;

import com.engine.common.util.ServiceUtil;
import com.engine.htsc.jgxt.service.JgxtDataToOtherService;
import com.engine.htsc.jgxt.service.imp.JgxtDataToOtherServiceImp;
import com.engine.htsc.jgxt.service.imp.JgxtsdbmtodetailServerImp;
import weaver.conn.RecordSet;
import weaver.conn.RecordSetData;
import weaver.conn.RecordSetDataSource;
import weaver.general.Util;
import weaver.interfaces.htsc.GlobatTools.JAVATools;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xf
 * @version 1.0.0
 * @ClassName Jgxt.java
 * @createTime 2021年11月10日 15:37:00
 */
public class JgxtDataToOther implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
      try {
          JAVATools.SetCmdwritelog("监管协同流程", "判断消息是否需要发送");
          RecordSet rs = new RecordSet();
          String requestid = requestInfo.getRequestid();
          String requestname = requestInfo.getRequestManager().getRequestname();
          String tablename = requestInfo.getRequestManager().getBillTableName();
//          String nodeid=Util.null2String(requestInfo.getRequestManager().getNodeid());
          Map<String, Object> map = new HashMap<>();
          map.put("requestid", requestid);
          map.put("tablename", tablename);
//          map.put("nodeid", nodeid);
          ServiceUtil.getService(JgxtDataToOtherServiceImp.class).innserotherdata(map);
      }catch (Exception exo){

      }
        return Action.SUCCESS;

    }
}
