package weaver.interfaces.htsc.jjhyy;

import com.engine.common.util.ServiceUtil;
import com.engine.core.impl.Service;
import com.engine.htsc.jjhyy.dao.JjhyybaseDao;
import com.engine.htsc.jjhyy.service.JjhyybaseService;
import com.engine.htsc.jjhyy.service.impl.JjhyybaseServiceImpl;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author K1810015
 * @version 1.0.0
 * @ClassName jjhyydetailnumber.java
 * @createTime 2022年03月18日 10:30:00
 */
public class Jjhyydetailnumber implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
      String requestid= Util.null2String(requestInfo.getRequestid());
      String tablename= requestInfo.getRequestManager().getBillTableName();
      Map<String,Object> map=new HashMap<>();
      map.put("requestid",requestid);
      map.put("tablename",tablename);
      User user=  requestInfo.getRequestManager().getUser();
      JjhyybaseService jjhyybaseService= ServiceUtil.getService(JjhyybaseServiceImpl.class);
      jjhyybaseService.createdetailnumber(user,map);
      return Action.SUCCESS;
    }

}
