package weaver.interfaces.htsc.lhcd;

import com.engine.common.util.ServiceUtil;
import com.engine.htsc.lhcd.Service.LhcdunifiedService;
import com.engine.htsc.lhcd.Service.impl.LhcdunifiedServiceimpl;
import com.weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.htsc.GlobatTools.JAVATools;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xf
 * @version 1.0.0
 * @ClassName LhcdSendeformAction.java
 * @createTime 2021年12月30日 14:18:00
 */
public class LhcdSendeformAction  extends BaseBean implements Action {



    private LhcdunifiedService Lhcdunified()
    {
        return ServiceUtil.getService(LhcdunifiedServiceimpl.class);
    }


    @Override
    public String execute(RequestInfo requestInfo) {
        try {
            Map<String, String> map = new HashMap<>();
            String requestid = Util.null2String(requestInfo.getRequestid());
            map.put("requestid", requestid);
            Lhcdunified().innertunified(map);
        }catch (Exception exo){
            JAVATools.SetCmdwritelog("调用电子存档接口错误");
        }
        return Action.SUCCESS;
    }
}
