package weaver.interfaces.htsc.payment;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.interfaces.htsc.comInfo.PropBean;
import weaver.interfaces.schedule.BaseCronJob;

public class ProcessedDataDeleteJob extends BaseCronJob {
    private Log log = LogFactory.getLog(this.getClass());

    @Override
    public void execute() {
        RecordSet rs = new RecordSet();
        log.info("======定时任务定时任务删除门户已办数据开始======");
        try {
            String deleteSql = "delete from t_havedo t " +
                "where ( t.title like '%4922%测试%' or t.title like '%测试%4922%' or t.title like '%数字办公系统测试%' or t.title like '%-4922%' or t.title like '%4922-%') " +
                "and t.systemtype ='HTOA'" ;
            log.info("定时任务定时任务删除门户已办数据Sql:"+deleteSql);
            rs.executeSqlWithDataSource(deleteSql,"portalapp");
        }catch(Exception e) {
            e.printStackTrace();
            new BaseBean().writeLog("定时任务定时任务删除门户已办数据 t_havedo 失败"+e.getStackTrace());
        }
    }

}
