package weaver.interfaces.htsc.payment.common.pdfprocess;


import java.util.List;

/**
 * 业务处理接口
 * 实现对接pdf系统的业务逻辑封装
 * @author K1810012
 */
public interface PDFBizProcessor {

  List<SyncPdf> queryUnSyncPdfList();

  /**
   * by size
   * @param size
   * @return
   */
  List<SyncPdf> queryUnSyncPdfList(int size);

  /**
   * 更新表同步状态
   */
  void modifySyncStatus(PdfStatusEnum status, String id);

  void handle(List<SyncPdf> pdfs);
}
