package weaver.interfaces.htsc.seal;


import com.engine.common.util.ServiceUtil;
import com.engine.htsc.seal.service.SealApplicationService;
import com.weaver.general.BaseBean;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

public class SealLabelAction extends BaseBean implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = requestInfo.getRequestid();
        writeLog("----SealLabelAction-------" + requestid);
        try{
            SealApplicationService sealApplicationService = ServiceUtil.getService(SealApplicationService.class);
            sealApplicationService.checkElectronicSealLabel(requestid,null);

            return Action.SUCCESS;
        } catch (Exception e) {
            e.printStackTrace();
            writeLog( "异常参考:" + e );
            requestInfo.getRequestManager().setMessageid( "111111" );
            requestInfo.getRequestManager().setMessagecontent( "流程提交失败" );
            return Action.FAILURE_AND_CONTINUE;
        }
    }
}
