package weaver.interfaces.htsc.seal;


import com.engine.common.util.ServiceUtil;
import com.engine.htsc.seal.service.SubSealApplicationService;
import com.weaver.general.BaseBean;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

public class SealMailLabelAction extends BaseBean implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        String requestid = requestInfo.getRequestid();
        writeLog("----SealMailLabelAction-------" + requestid);
        try{
            SubSealApplicationService subSealApplicationService = ServiceUtil.getService(SubSealApplicationService.class);
            subSealApplicationService.checkMailLabel(requestid,null);

            return Action.SUCCESS;
        } catch (Exception e) {
            e.printStackTrace();
            writeLog( "异常参考:" + e );
            requestInfo.getRequestManager().setMessageid( "111111" );
            requestInfo.getRequestManager().setMessagecontent( "流程提交失败" );
            return Action.FAILURE_AND_CONTINUE;
        }
    }
}
