package weaver.interfaces.htsc.workflow.odoc;

import weaver.general.BaseBean;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.RequestInfo;

/**
 * 流程附件上传共享盘返回加密文件
 *
 */
public class FileEncryptionAction2 extends BaseBean implements Action {

    @Override
    public String execute(RequestInfo requestInfo) {
        BaseBean bb = new BaseBean();

        bb.writeLog("FileEncryptionAction2===start====");
        bb.writeLog(System.currentTimeMillis());

        Thread thread = new Thread() {
            public void run() {
                CrmRunnable crmRunnable = new CrmRunnable();
                crmRunnable.rmsFileEncryption(requestInfo);
            }
        };
        thread.start();
        bb.writeLog("FileEncryptionAction2===end====");
        bb.writeLog(System.currentTimeMillis());
        return Action.SUCCESS;
    }
}
