/*
 *
 *  * Copyright (c) 2001- 泛微软件.
 *  * 泛微协同商务系统,版权所有.
 *
 */

package weaver.interfaces.htsc.wpscenter;

import java.util.Map;

/**
 * 文档转换接口
 * @Author leiwb
 * @Date 2020/8/6
 */
public interface DocumentConvertInterface {

    /**
     * 文档转换成PDF
     * @param paramsMap 传参
     * @return 转成的格式文档imagefileId
     */
    int ConvertToPDF(Map<String,Object> paramsMap);

    /**
     * 文档接受修订后转PDF
     * @param paramsMap
     * @return
     */
    int ConvertToPDFWithoutRevision(Map<String,Object> paramsMap);

    /**
     * 文档删除批注，接受修订后，转PDF
     * @param paramsMap
     * @return
     */
    int ConvertToPDFWithoutRevisionAndComment(Map<String,Object> paramsMap);

}
